c
c
c         Centroid display box for
c         Magellan guider cameras.
c         ------------------------
c
       subroutine cbox (fnc, arg)
c
       implicit  none
c
       real*4    r4, r4val
       integer*4 fnc, i4, i4val
       integer*4 x0, y0, xb, yb
       integer*4 y1, y2, y3, y4, y5
       integer*4 y2val (172), y3val (172)
       integer*4 y4val (172), y5val (172)
       integer*4 valptr1, valptr2, xval, yval
       integer*4 blk,  gry,  hlt,  wht
       integer*4 red,  yel,  grn,  bkg
       integer*4 blk1, gry1, wht1, red1
       integer*4 yel1, grn1, blk2, grn2
       integer*4 fontbuf (114688)
       character*1 gstat
       character*37 msg801
       character arg*(*), chr2*2, chr3*3, chr4*4, chr6*6
       character newbk*5, oldbk*5, newit*2, oldit*2
       character newtc*5, oldtc*5, newfw*5, oldfw*5
       character newmx*5, oldmx*5, newpa*4, oldpa*4
       character newdx*5, olddx*5, newdy*5, olddy*5
c
       common / colors  / blk,  gry,  hlt,  wht,
     :                    red,  yel,  grn,  bkg
       common / fontptr / blk1, gry1, wht1, red1,
     :                    yel1, grn1, blk2, grn2
       common / fontcom / fontbuf
       common / ms8com / msg801
c
       data x0 / 0 /, y0 / 1 /, xb / 213 /, yb / 354 /
       data y1 / 8 /, y2 / 143 /, y3 / 193 /, y4 / 240 /, y5 / 309 /
       data y2val / 172 * 144 /, y3val / 172 * 194 /
       data y4val / 172 * 241 /, y5val / 172 * 310 /
       data valptr1 / 6 /, valptr2 / 1 /
c
       if     (fnc .eq. 0) then
          msg801 = '801;                                '
          call coolfr (x0, y0, x0 + xb, y0 + yb)
c
          call opqchr1 ('guider  off       sn    ',
     :                  x0 +  12, y0 + y1,      fontbuf (blk1))
          call opqchr1 ('tc       xf  nor  yf nor',
     :                  x0 +  12, y0 + y1 + 16, fontbuf (blk1))
          call opqchr1 ('mx       pa       px    ',
     :                  x0 +  12, y0 + y1 + 32, fontbuf (blk1))
          call opqchr1 ('bk        x       bx  31',
     :                  x0 +  12, y0 + y1 + 48, fontbuf (blk1))
          call opqchr1 ('fw        y       it    ',
     :                  x0 +  12, y0 + y1 + 64, fontbuf (blk1))
          call opqchr1 (char (127),
     :                  x0 +  83, y0 + y1 + 49, fontbuf (blk1))
          call opqchr1 (char (127),
     :                  x0 +  83, y0 + y1 + 65, fontbuf (blk1))
c
c
c         Draw sub-panels for graphics.
c         -----------------------------
c
          call subfrm (x0 + 22, y0 +  93, x0 + xb - 8, y0 + 198)
          call subfrm (x0 + 22, y0 + 203, x0 + xb - 8, y0 + 346)
c
c
c         Draw and label axes for
c         total count and full-width.
c         ---------------------------
c
          call opqvec (x0 + 27,      y0 + y2 - 45,
     :                 x0 + 27,      y0 + y2,      blk)
          call opqvec (x0 + 27,      y0 + y3 - 45,
     :                 x0 + 27,      y0 + y3,      blk)
c
          call opqvec (x0 + xb - 13, y0 + y2 - 45,
     :                 x0 + xb - 13, y0 + y2,      blk)
          call opqvec (x0 + xb - 13, y0 + y3 - 45,
     :                 x0 + xb - 13, y0 + y3,      blk)
c
          call opqvec (x0 + 27,      y0 + y2,
     :                 x0 + xb - 13, y0 + y2,      blk)
          call opqvec (x0 + 27,      y0 + y3,
     :                 x0 + xb - 13, y0 + y3,      blk)
c
          call opqchr1 ('t', x0 + 10, y0 + 108, fontbuf (blk1))
          call opqchr1 ('c', x0 + 10, y0 + 120, fontbuf (blk1))
c
          call opqchr1 ('f', x0 + 10, y0 + 158, fontbuf (blk1))
          call opqchr1 ('w', x0 + 10, y0 + 170, fontbuf (blk1))
c
c
c         Draw and label axes for az and el errors.
c         -----------------------------------------
c
          call opqvec (x0 + 27,      y0 + y4 - 32,
     :                 x0 + 27,      y0 + y4 + 32, blk)
          call opqvec (x0 + 27,      y0 + y5 - 32,
     :                 x0 + 27,      y0 + y5 + 32, blk)
c
          call opqvec (x0 + xb - 13, y0 + y4 - 32,
     :                 x0 + xb - 13, y0 + y4 + 32, blk)
          call opqvec (x0 + xb - 13, y0 + y5 - 32,
     :                 x0 + xb - 13, y0 + y5 + 32, blk)
c
          call opqvec (x0 + 27,      y0 + y4,
     :                 x0 + xb - 13, y0 + y4,      blk)
          call opqvec (x0 + 27,      y0 + y5,
     :                 x0 + xb - 13, y0 + y5,      blk)
c
          call opqchr1 ('A', x0 + 10, y0 + 226, fontbuf (blk1))
          call opqchr1 ('Z', x0 + 10, y0 + 241, fontbuf (blk1))
c
          call opqchr1 ('E', x0 + 10, y0 + 295, fontbuf (blk1))
          call opqchr1 ('L', x0 + 10, y0 + 310, fontbuf (blk1))
c
c
c         Background intensity.
c         ---------------------
c
       elseif (fnc .eq. 1) then
          i4 = nint (r4val (arg))
          call iform (i4, newbk, 1)
          call smalltext (newbk, oldbk,
     :                    x0 + 28, y0 + y1 + 48, fontbuf (blk1))
c
c
c         X-position.
c         -----------
c
       elseif (fnc .eq. 2) then
          r4 = r4val (arg)
          call fform (r4, newdx, 1, 1)
          call smalltext (newdx, olddx,
     :                    x0 + 100, y0 + y1 + 48, fontbuf (blk1))
          msg801(11:15) = newdx
c
c
c         Y-position.
c         -----------
c
       elseif (fnc .eq. 3) then
          r4 = r4val (arg)
          call fform (r4, newdy, 1, 1)
          call smalltext (newdy, olddy,
     :                    x0 + 100, y0 + y1 + 64, fontbuf (blk1))
          msg801(16:20) = newdy
c
c
c         Total count.
c         ------------
c
       elseif (fnc .eq. 4) then
          i4 = nint (r4val (arg))
          call iform (i4, newtc, 1)
          call smalltext (newtc, oldtc,
     :                    x0 + 28, y0 + y1 + 16, fontbuf (blk1))
          msg801(21:25) = newtc
c
c
c         FWHM.
c         -----
c
       elseif (fnc .eq. 5) then
          r4 = r4val (arg)
          call fform (r4, newfw, 2, 1)
          call smalltext (newfw, oldfw,
     :                    x0 + 28, y0 + y1 + 64, fontbuf (blk1))
          msg801(5:9) = newfw
c
c
c         Maximum intensity.
c         ------------------
c
       elseif (fnc .eq. 6) then
          i4 = nint (r4val (arg))
          call iform (i4, newmx, 1)
          call smalltext (newmx, oldmx,
     :                    x0 + 28, y0 + y1 + 32, fontbuf (blk1))
c
c
c         Number of iterations.
c         ---------------------
c
       elseif (fnc .eq. 7) then
          i4 = i4val (arg)
          call iform (i4, newit, 1)
          call smalltext (newit, oldit,
     :                    x0 + 188, y0 + y1 + 64, fontbuf (blk1))
c
c
c         Pixel scale.
c         ------------
c
       elseif (fnc .eq. 8) then
          i4 = nint (1000. * r4val (arg))
          call iform (i4, chr3, 3)
          call opqchr1 (chr3, x0 + 180, y0 + y1 + 32, fontbuf (blk1))
c
c
c         Position angle.
c         ---------------
c
       elseif (fnc .eq. 9) then
          r4 = r4val (arg)
          i4 = nint (r4)
          call iform (i4, newpa, 1)
          if ((i4 .eq. 0) .and. (r4 .lt. 0.0)) then
             newpa (3:3) = '-'
          endif
          call smalltext (newpa, oldpa,
     :                    x0 + 108, y0 + y1 + 32, fontbuf (blk1))
c
c
c         Guider sensitivity.
c         -------------------
c
       elseif (fnc .eq. 10) then
          call fform (r4val (arg), chr3, 1, 1)
          call opqchr1 (chr3, x0 + 180, y0 + y1, fontbuf (blk1))
c
c
c         Guider status.
c         --------------
c
       elseif (fnc .eq. 11) then
          i4 = i4val (arg)
          if     (i4 .eq. 1) then
             chr4 = ' off'
          elseif (i4 .eq. 2) then
             chr4 = 'calc'
          elseif (i4 .eq. 3) then
             chr4 = 'move'
          else
             chr4 = '????'
          endif
          gstat = char (i4 + 48)
          msg801(10:10) = gstat
c
          call opqchr1 (chr4, x0 + 68, y0 + y1, fontbuf (blk1))
c
c
c         Guider box size.
c         ----------------
c
       elseif (fnc .eq. 12) then
          i4 = i4val (arg)
          call iform (i4, chr2, 1)
          call opqchr1 (chr2, x0 + 188, y0 + y1 + 48, fontbuf (blk1))
c
c
c         PA color.
c         ----------------
c
       elseif (fnc .eq. 13) then
          i4 = i4val (arg)
          if (i4 .ne. 0) then
              call opqchr1 ("pa", x0 + 84, y0 + y1 + 32, fontbuf (grn1))
          else
              call opqchr1 ("pa", x0 + 84, y0 + y1 + 32, fontbuf (blk1))
          endif
c
c
c         Extended send
c         ---------------
c
       elseif (fnc .eq. 14) then
          i4 = i4val (arg)
          if (i4 .ne. 0) then
              call opqchr1 ("es", x0 + 108, y0 + y1, fontbuf (red1))
          else
              call opqchr1 ("  ", x0 + 108, y0 + y1, fontbuf (blk1))
          endif
c
c
c         Plot points.  The argument in each
c         case is scaled to 1.0.  Erase the
c         previous value (5 points ahead),
c         then draw the current value.
c
c         Advance the plot position after the
c         Elevation error point is plotted/
c
c         First, plot total count.
c         --------------------------------------
c
       elseif (fnc .eq. 20) then
          xval = x0 + 27 + valptr1
          yval = y2val (valptr1)
          if (yval .eq. (y0 + y2)) then
             call opqwrt (blk, 1, xval, yval)
          else
             call opqwrt (bkg, 1, xval, yval)
          endif
c
          xval = x0 + 27 + valptr2
          yval = nint (45. * r4val (arg))
          yval = min (yval, 45)
          yval = max (yval,  0)
          yval = y0 + y2 - yval
          call opqwrt (wht, 1, xval, yval)
          y2val (valptr2) = yval
c
c
c         Plot FWHM.
c         ----------
c
       elseif (fnc .eq. 30) then
          xval = x0 + 27 + valptr1
          yval = y3val (valptr1)
          if (yval .eq. (y0 + y3)) then
             call opqwrt (blk, 1, xval, yval)
          else
             call opqwrt (bkg, 1, xval, yval)
          endif
c
          xval = x0 + 27 + valptr2
          yval = nint (45. * r4val (arg))
          yval = min (yval, 45)
          yval = max (yval,  0)
          yval = y0 + y3 - yval
          call opqwrt (wht, 1, xval, yval)
          y3val (valptr2) = yval
c
c
c         Plot azimuth error.
c         -------------------
c
       elseif (fnc .eq. 40) then
          xval = x0 + 27 + valptr1
          yval = y4val (valptr1)
          if (yval .eq. (y0 + y4)) then
             call opqwrt (blk, 1, xval, yval)
          else
             call opqwrt (bkg, 1, xval, yval)
          endif
c
          xval = x0 + 27 + valptr2
          yval = nint (32. * r4val (arg))
          yval = min (yval,  32)
          yval = max (yval, -32)
          yval = y0 + y4 - yval
          call opqwrt (wht, 1, xval, yval)
          y4val (valptr2) = yval
c
c
c         Plot elevation error, then
c         advance the plot position.
c         --------------------------
c
       elseif (fnc .eq. 50) then
          xval = x0 + 27 + valptr1
          yval = y5val (valptr1)
          if (yval .eq. (y0 + y5)) then
             call opqwrt (blk, 1, xval, yval)
          else
             call opqwrt (bkg, 1, xval, yval)
          endif
c
          xval = x0 + 27 + valptr2
          yval = nint (32. * r4val (arg))
          yval = min (yval,  32)
          yval = max (yval, -32)
          yval = y0 + y5 - yval
          call opqwrt (wht, 1, xval, yval)
          y5val (valptr2) = yval
c
          valptr1 = valptr1 + 1
          if (valptr1 .gt. 172) valptr1 = 1
          valptr2 = valptr2 + 1
          if (valptr2 .gt. 172) valptr2 = 1
c
       endif
c
       return
       end
