c
c
c         Serial communication program
c         for link to Magellan TCS.
c         ----------------------------
c
       subroutine tcs
c
       implicit none
c
       real*8    errtm, utime, mjd
       real*4    azg, elg, azerr, elerr, parall
       integer*4 tcscur
       integer*4 newx, newy
       integer*4 incur, xcur (5), ycur (5)
       integer*4 timer1, timer2, timer3, timer4
       integer*4 step, i, i4, lrc, ier, nc
       integer*4 errfl, nsnd, nrcv, errct, mjday
       integer*4 sndbuf (100), rcvbuf (100)
       logical*4 gflag, cmdfl, ok
       logical*4 apaflg, esflg
       integer*4 dtime, time5, time6, time7, time8, time9
       character chr2*2, msg*37
       integer*4 mxerr
       integer*4 tptr
       character*80 edsms1, edsms2
       integer*4 cmdlen
       integer*4 j
       logical*4 netok, mgcsr, netcmd
       integer*2 netkey
       integer*4 cmd, num
       character alph*8, pbxmsg*24
       real     r4(3)
       logical*4 negflag
       character*24 c24
       integer*4 hh, mm, ss, hs
       integer*4 mbbits
c
       common / sr1com / errtm, errfl, nsnd,
     :                   nrcv, sndbuf, rcvbuf
       common / clkcom / utime, mjday
       common / timcom / timer1, timer2, timer3, timer4
       common / gdscom / gflag, azg, elg, azerr, elerr, parall
       common / flgcom / apaflg, esflg
       integer*4 gdrfl, xflip, yflip, box
       real*4    sens, pa, px
       common / gdrcom / gdrfl, sens, xflip, yflip, pa, px, box
       common / cr1com / incur, xcur, ycur
       real*4   rx, ry, cx, cy
       integer*4 bbits
       integer*4 msecur, gdrcur
       common / msecom / rx, ry, cx, cy, bbits, msecur, gdrcur
       integer*4 edsptr, tcsptr
       character*80 edsmsg (100)
       common / edscom / edsptr, tcsptr, edsmsg
       integer*4 camlen
       character*22 camcmd
       common / camcom / camlen, camcmd
       real*8 utset
       integer*4 clkfl, ppm
       common / clkctl / utset, clkfl, ppm
       integer*4 mmoden, mclick
       common / mmdcom / mmoden, mclick
       character*37 msg801
       common / ms8com / msg801
c
       data time8 / -2097000 /
       data msecur / 1 /
       data tcscur / 0 /
       data gdrcur / 5 /
       data step / 1 /
       data mxerr / 3 /
c
c
c         Guide command.  Send this message when a
c         request is issued elsewhere in the program.
c         -------------------------------------------
c
       if     (step .eq. 1) then
          if (gflag) then
c
             i4 = nint (azg * 100.)
             i4 = i4 + 50
             i4 = min (i4, 99)
             i4 = max (i4,  0)
             call iform (i4, msg (4:5), 2)
c
             i4 = nint (elg * 100.)
             i4 = i4 + 50
             i4 = min (i4, 99)
             i4 = max (i4,  0)
             call iform (i4, msg (6:7), 2)
c
             if (esflg) then
c
                 i4 = nint (azerr * 1000.)
                 i4 = i4 + 500
                 i4 = min (i4,999)
                 i4 = max (i4,  0)
                 call iform (i4, msg ( 8:10), 3)
c
                 i4 = nint (elerr * 1000.)
                 i4 = i4 + 500
                 i4 = min (i4,999)
                 i4 = max (i4,  0)
                 call iform (i4, msg (11:13), 3)
c
                 sndbuf (3) = ichar ('7')
                 nsnd = 16
             else
                 sndbuf (3) = ichar ('1')
                 nsnd = 10
             endif
             do 130 i = 4, nsnd - 3
                sndbuf (i) = ichar (msg (i:i))
  130        continue
c
             cmdfl = .true.
             step = 11
          else
             step = 2
          endif
c
c
c         Angle request.
c         -------------------------------------------
c
       elseif (step .eq. 2) then
          dtime = timer1 - time5
          if (dtime .lt. 0) dtime = dtime + 1000000000
          if ((dtime .gt. 580) .and. apaflg) then
             sndbuf (3) = ichar ('5')
             nsnd = 4
             cmdfl = .true.
             step = 12
          else
             if (.not. apaflg) time5 = timer1
             step = 3
          endif
c
c
c         Cursor request.
c         -------------------------------------------
c
       elseif (step .eq. 3) then
          dtime = timer1 - time6
          if (dtime .lt. 0) dtime = dtime + 1000000000
          if (dtime .gt. 58) then
c
             i4 = xcur(gdrcur)
             i4 = min (i4, 9999)
             i4 = max (i4,    0)
             call iform (i4, msg (4:7), 4)
             i4 = ycur(gdrcur)
             i4 = min (i4, 9999)
             i4 = max (i4,    0)
             call iform (i4, msg (8:11), 4)
c
             i4 = xcur(msecur)
             i4 = min (i4, 9999)
             i4 = max (i4,    0)
             call iform (i4, msg (12:15), 4)
             i4 = ycur(msecur)
             i4 = min (i4, 9999)
             i4 = max (i4,    0)
             call iform (i4, msg (16:19), 4)
c
             if (mmoden .eq. 3) then
                 mbbits = or (bbits, mclick)
                 mclick = 0
                 msg (20:20) = char(and(mbbits,7)+48)
             else
                 msg (20:20) = '0'
             endif
c
             sndbuf (3) = ichar ('6')
             nsnd = 23
             do 135 i = 4, nsnd - 3
                sndbuf (i) = ichar (msg (i:i))
  135        continue
             cmdfl = .true.
             step = 13
          else
             step = 4
          endif
c
c
c         EDS message
c         -------------------------------------------
c
       elseif (step .eq. 4) then
           if (edsptr .ne. tcsptr) then
c              calculate queue length
               i4 = edsptr - tcsptr
               if (i4 .lt.  0) i4 = i4 + 100
               if (i4 .gt. 99) i4 = 99
               call iform (i4, chr2, 2)
               tptr = tcsptr+1
               if (tptr .gt. 100) tptr = 1
               edsms1 = edsmsg (tptr)
               edsms2 (8:52) = edsms1 (1:45)
               edsms2 (3:3) = '2'
               edsms2 (4:5) = chr2
               edsms2 (6:7) = '45'
               nsnd = 55
               do 235 i = 3, nsnd - 3
                   sndbuf (i) = ichar (edsms2 (i:i))
235            continue
               cmdfl = .true.
               step = 14
           else
               step = 5
           endif
c
c
c         command request
c         -------------------------------------------
c
       elseif (step .eq. 5) then
          dtime = timer1 - time7
          if (dtime .lt. 0) dtime = dtime + 1000000000
          if (dtime .gt. 145) then
               nsnd = 4
               sndbuf (3) = ichar ('9')
               cmdfl = .true.
               step = 15
           else
               step = 6
           endif
c
c
c         command 
c         -------------------------------------------
c
       elseif (step .eq. 6) then
          if (camlen .gt. 0) then
               sndbuf (3) = ichar ('8')
               i4 = camlen
               sndbuf (4) = i4/10 + 48
               sndbuf (5) = (camlen-(i4/10)*10) + 48
               do 238 i = 1, camlen
                  sndbuf (5+i) = ichar (camcmd (i:i))
238            continue
               nsnd = 8+camlen
               camlen = 0
               cmdfl = .true.
               step = 16
           else
               step = 7
           endif
c
c
c         UT request
c         -------------------------------------------
c
       elseif (step .eq. 7) then
          dtime = timer1 - time8
          if (dtime .lt. 0) dtime = dtime + 1000000000
          if (dtime .gt. 2100000) then
               nsnd = 4
               sndbuf (3) = ichar ('4')
               cmdfl = .true.
               step = 17
           else
               step = 8
           endif
c
c
c         put cursors into eds
c         -------------------------------------------
c
       elseif (step .eq. 8) then
          dtime = timer1 - time9
          if (dtime .lt. 0) dtime = dtime + 1000000000
          if (dtime .gt. 580) then
               do 820 i=1,5
                   msg = '820;00000000'
                   msg(3:3) = char (i+48)
                   i4 = xcur(i)
                   i4 = min (i4, 9999)
                   i4 = max (i4,    0)
                   call iform (i4, msg ( 5: 8), 4)
                   i4 = ycur(i)
                   i4 = min (i4, 9999)
                   i4 = max (i4,    0)
                   call iform (i4, msg ( 9:12), 4)
                   call puteds (2, msg)
820            continue
               call puteds (2, msg801)
               time9 = timer1
               step = 1
           else
               step = 1
           endif
c
       endif
c
c
c         Calculate the LRC checksum, and
c         encode it as 2 hex-ascii digits.
c         Then send the command sequence.
c         --------------------------------
c
       if (cmdfl) then
          sndbuf (1) = ichar (':')
          sndbuf (2) = ichar ('N')
c
          if (nsnd .ge. 5) then
              lrc = 0
              do 140 i = 2, nsnd - 3
                 lrc = xor (lrc, sndbuf (i))
140           continue
c
              i4 = and (lrc, 15)
              if (i4 .gt. 9) i4 = i4 + 7
              sndbuf (nsnd - 1) = i4 + 48
c
              i4 = lrc / 16
              if (i4 .gt. 9) i4 = i4 + 7
              sndbuf (nsnd - 2) = i4 + 48
          endif
c
          sndbuf (nsnd) = 13
          errfl = - 100
          cmdfl = .false.
c
       endif
c
c
c         If not actually waiting for a reply,
c         skip the rest of the program.  This
c         avoids various problems with the
c         error count.
c
c         Also skip the rest of the program if
c         the communication is still pending.
c         ------------------------------------
c
       if (step .le. 10) go to 990
       if (errfl .lt. 0) go to 990
       ok = errfl .eq. 0
c
c
c         Read the guide command response from the
c         TCS.  Re-transmit only if you get a valid
c         response from the main drive computer
c         indicating that the original message was
c         not received correctly.
c         -----------------------------------------
c
c
       if     (step .eq. 11) then
          step = 1
          gflag = .false.
          if (ok) then
             ok =         (rcvbuf (4) .eq. 48)
             ok = ok .or. (rcvbuf (4) .eq. 49)
c
             ok = ok .and. (nrcv .eq. 5)
             ok = ok .and. (rcvbuf (1) .eq. 126)
             ok = ok .and. (rcvbuf (2) .eq.  78)
             if (esflg) then
                 ok = ok .and. (rcvbuf (3) .eq.  ichar ('7'))
             else
                 ok = ok .and. (rcvbuf (3) .eq.  ichar ('1'))
             endif
c
             if (ok) then
                if (rcvbuf (4) .eq. 48) then
                   step = 1
                   gflag = .true.
                   ok = .false.
                   if (errct .lt. mxerr) then
                      msg = '041: TCS guide cmd transmit error'
                      call putmsg (msg)
                   endif
                endif
c
             else
                if (errct .lt. mxerr) then
                   call putmsg ('043: TCS guide command data error')
                endif
             endif
c
          else
             if (errct .lt. mxerr) then
                msg = '044: TCS guide command com error X'
                msg (34:34) = char (errfl + 48)
                call putmsg (msg)
             endif
          endif
c
c
c         Read the angle request response from the TCS
c         --------------------------------------------
c
c
       elseif (step .eq. 12) then
          step = 3
          if (ok) then
             ok = ok .and. (nrcv .eq. 33)
             ok = ok .and. (rcvbuf (1) .eq. ichar('~'))
             ok = ok .and. (rcvbuf (2) .eq. ichar('N'))
             ok = ok .and. (rcvbuf (3) .eq. ichar('5'))
c
             if (ok) then
                lrc = 0
                do 320 i = 2, nrcv - 3
                   lrc = xor (lrc, rcvbuf (i))
320             continue
c
                i4 = rcvbuf (nrcv - 1) - 48
                if (i4 .gt. 9) i4 = i4 - 7
                lrc = lrc - i4
c
                i4 = rcvbuf (nrcv - 2) - 48
                if (i4 .gt. 9) i4 = i4 - 7
                lrc = lrc - (16 * i4)
c
                if (lrc .eq. 0) then
                   i4 =             rcvbuf ( 4) - 48
                   i4 = (10 * i4) + rcvbuf ( 5) - 48
                   i4 = (10 * i4) + rcvbuf ( 6) - 48
                   i4 = (10 * i4) + rcvbuf ( 7) - 48
                   i4 = (10 * i4) + rcvbuf ( 8) - 48
                   i4 = (10 * i4) + rcvbuf ( 9) - 48
                   i4 = (10 * i4) + rcvbuf (10) - 48
                   i4 = (10 * i4) + rcvbuf (11) - 48
                   i4 = (10 * i4) + rcvbuf (12) - 48
                   pa = i4/1000000.0 - 500.0
                   call cbox (9, pa)
                   i4 =             rcvbuf (13) - 48
                   i4 = (10 * i4) + rcvbuf (14) - 48
                   i4 = (10 * i4) + rcvbuf (15) - 48
                   i4 = (10 * i4) + rcvbuf (16) - 48
                   i4 = (10 * i4) + rcvbuf (17) - 48
                   i4 = (10 * i4) + rcvbuf (18) - 48
                   i4 = (10 * i4) + rcvbuf (19) - 48
                   i4 = (10 * i4) + rcvbuf (20) - 48
                   i4 = (10 * i4) + rcvbuf (21) - 48
                   parall = i4/1000000.0 - 500.0
                   i4 =             rcvbuf (22) - 48
                   i4 = (10 * i4) + rcvbuf (23) - 48
                   i4 = (10 * i4) + rcvbuf (24) - 48
                   i4 = (10 * i4) + rcvbuf (25) - 48
                   i4 = (10 * i4) + rcvbuf (26) - 48
                   i4 = (10 * i4) + rcvbuf (27) - 48
                   i4 = (10 * i4) + rcvbuf (28) - 48
                   i4 = (10 * i4) + rcvbuf (29) - 48
                   i4 = (10 * i4) + rcvbuf (30) - 48
                   px = i4/1000000.0
                   call cbox (8, px)
                   time5 = timer1
                else
                   ok = .false.
                   if (errct .lt. mxerr) then
                      msg = '041: TCS angle command checksum error'
                      call putmsg (msg)
                   endif
                endif
c
             else
                if (errct .lt. mxerr) then
                   call putmsg ('043: TCS angle command data error')
                endif
             endif
c
          else
             if (errct .lt. mxerr) then
                msg = '044: TCS angle command com error X'
                msg (34:34) = char (errfl + 48)
                call putmsg (msg)
             endif
          endif
c
c
c         Read the cursor request response from the TCS
c         --------------------------------------------
c
c
       elseif (step .eq. 13) then
          step = 4
          if (ok) then
             ok = ok .and. (nrcv .eq. 14)
             ok = ok .and. (rcvbuf (1) .eq. ichar('~'))
             ok = ok .and. (rcvbuf (2) .eq. ichar('N'))
             ok = ok .and. (rcvbuf (3) .eq. ichar('6'))
c
             if (ok) then
                lrc = 0
                do 321 i = 2, nrcv - 3
                   lrc = xor (lrc, rcvbuf (i))
321             continue
c
                i4 = rcvbuf (nrcv - 1) - 48
                if (i4 .gt. 9) i4 = i4 - 7
                lrc = lrc - i4
c
                i4 = rcvbuf (nrcv - 2) - 48
                if (i4 .gt. 9) i4 = i4 - 7
                lrc = lrc - (16 * i4)
c
                if (lrc .eq. 0) then
                   i4 =             rcvbuf ( 4) - 48
                   i4 = (10 * i4) + rcvbuf ( 5) - 48
                   i4 = (10 * i4) + rcvbuf ( 6) - 48
                   i4 = (10 * i4) + rcvbuf ( 7) - 48
                   newx = i4
                   i4 =             rcvbuf ( 8) - 48
                   i4 = (10 * i4) + rcvbuf ( 9) - 48
                   i4 = (10 * i4) + rcvbuf (10) - 48
                   i4 = (10 * i4) + rcvbuf (11) - 48
                   newy = i4
                   if (tcscur .gt. 0) then
                       if ((newx .ne. xcur(tcscur)) .or.
     :                   (newy .ne. ycur(tcscur))) then
                           call curupa (tcscur, newx, newy)
                       endif
                   endif
                   time6 = timer1
                else
                   ok = .false.
                   if (errct .lt. mxerr) then
                      msg = '041: TCS cursor com checksum error'
                      call putmsg (msg)
                   endif
                endif
c
             else
                if (errct .lt. mxerr) then
                   call putmsg ('043: TCS cursor command data error')
                endif
             endif
c
          else
             if (errct .lt. mxerr) then
                msg = '044: TCS cursor command com error X'
                msg (35:35) = char (errfl + 48)
                call putmsg (msg)
             endif
          endif
c
c
c         Read the EDS response from the TCS
c         --------------------------------------------
c
c
       elseif (step .eq. 14) then
          step = 5
          if (ok) then
             ok = ok .and. (nrcv .eq. 5)
             ok = ok .and. (rcvbuf (1) .eq. ichar('~'))
             ok = ok .and. (rcvbuf (2) .eq. ichar('N'))
             ok = ok .and. (rcvbuf (3) .eq. ichar('2'))
c
             if (ok) then
c
                if (rcvbuf (4) .eq. ichar('1')) then
                    tcsptr = tcsptr+1
                    if (tcsptr .gt. 100) tcsptr = 1
                else
                   ok = .false.
                   if (errct .lt. mxerr) then
                      msg = '041: TCS EDS   command response error'
                      call putmsg (msg)
                   endif
                endif
c
             else
                if (errct .lt. mxerr) then
                   call putmsg ('043: TCS EDS   command data     error')
                endif
             endif
c
          else
             if (errct .lt. mxerr) then
                msg = '044: TCS EDS    command com error X'
                msg (35:35) = char (errfl + 48)
                call putmsg (msg)
             endif
          endif
c
c
c         Read the command request response from the TCS
c         --------------------------------------------
c
c
       elseif (step .eq. 15) then
          step = 6
          if (ok) then
             ok = ok .and. (nrcv .ge. 8)
             ok = ok .and. (rcvbuf (1) .eq. ichar('~'))
             ok = ok .and. (rcvbuf (2) .eq. ichar('N'))
             ok = ok .and. (rcvbuf (3) .eq. ichar('9'))
c
             if (ok) then
                lrc = 0
                do 322 i = 2, nrcv - 3
                   lrc = xor (lrc, rcvbuf (i))
322             continue
c
                i4 = rcvbuf (nrcv - 1) - 48
                if (i4 .gt. 9) i4 = i4 - 7
                lrc = lrc - i4
c
                i4 = rcvbuf (nrcv - 2) - 48
                if (i4 .gt. 9) i4 = i4 - 7
                lrc = lrc - (16 * i4)
c
                if (lrc .eq. 0) then
                   i4 =             rcvbuf ( 4) - 48
                   i4 = (10 * i4) + rcvbuf ( 5) - 48
                   cmdlen = i4+1
                   rcvbuf (5+cmdlen) = 13
                   if (cmdlen .gt. 1) then
                       j = 0
1500                   continue
                       j = j + 1
                       if (j .gt. cmdlen) go to 1598

                       netkey = rcvbuf (5+j)
                       netok = netcmd (netkey, cmd, alph, num, r4,
     :                   negflag, pbxmsg, c24)
                       if (.not. netok) then
                           msg = '809;1'//pbxmsg
                           call puteds (2, msg)
                           go to 1599
                       endif
                       if (cmd .ne. 0) then
                           netok = mgcsr (cmd, alph, num, r4,
     :                       negflag, pbxmsg, c24)
                           if (.not. netok) then
                               msg = '809;2'//pbxmsg
                               call puteds (2, msg)
                           else
                               msg = '809;0'
                               call puteds (2, msg)
                           endif
                           go to 1599
                       endif
                       go to 1500
1598                   continue
                       msg = '809;3command overrun'
                       call puteds (2, msg)
1599                   continue
                   endif
                   time7 = timer1
                else
                   ok = .false.
                   if (errct .lt. mxerr) then
                      msg = '041: TCS camera com checksum error'
                      call putmsg (msg)
                   endif
                endif
c
             else
                if (errct .lt. mxerr) then
                   call putmsg ('043: TCS camera command data error')
                endif
             endif
c
          else
             if (errct .lt. mxerr) then
                msg = '044: TCS camera command com error X'
                msg (35:35) = char (errfl + 48)
                call putmsg (msg)
             endif
          endif
c
c
c         Read the command response from the TCS
c         --------------------------------------------
c
c
       elseif (step .eq. 16) then
          step = 7
          if (ok) then
             ok = ok .and. (nrcv .ge. 8)
             ok = ok .and. (rcvbuf (1) .eq. ichar('~'))
             ok = ok .and. (rcvbuf (2) .eq. ichar('N'))
             ok = ok .and. (rcvbuf (3) .eq. ichar('8'))
c
             if (ok) then
                lrc = 0
                do 323 i = 2, nrcv - 3
                   lrc = xor (lrc, rcvbuf (i))
323             continue
c
                i4 = rcvbuf (nrcv - 1) - 48
                if (i4 .gt. 9) i4 = i4 - 7
                lrc = lrc - i4
c
                i4 = rcvbuf (nrcv - 2) - 48
                if (i4 .gt. 9) i4 = i4 - 7
                lrc = lrc - (16 * i4)
c
                if (lrc .eq. 0) then
                   i4 =             rcvbuf ( 4) - 48
                   i4 = (10 * i4) + rcvbuf ( 5) - 48
                   cmdlen = i4
                   if (cmdlen .gt. 0) then
                       msg = '                                     '
                       do 237 j=1,cmdlen
                           msg(j:j) = char(rcvbuf(5+j))
237                    continue
                       call putmsg ('808;'//msg)
                   endif
                else
                   ok = .false.
                   if (errct .lt. mxerr) then
                      msg = '041: TCS        com checksum error'
                      call putmsg (msg)
                   endif
                endif
c
             else
                if (errct .lt. mxerr) then
                   call putmsg ('043: TCS        command data error')
                endif
             endif
c
          else
             if (errct .lt. mxerr) then
                msg = '044: TCS        command com error X'
                msg (35:35) = char (errfl + 48)
                call putmsg (msg)
             endif
          endif
c
c
c         Read the command request response from the TCS
c         --------------------------------------------
c
c
       elseif (step .eq. 17) then
          step = 8
          if (ok) then
             ok = ok .and. (nrcv .eq. 14)
             ok = ok .and. (rcvbuf (1) .eq. ichar('~'))
             ok = ok .and. (rcvbuf (2) .eq. ichar('N'))
             ok = ok .and. (rcvbuf (3) .eq. ichar('4'))
c
             if (ok) then
                lrc = 0
                do 324 i = 2, nrcv - 3
                   lrc = xor (lrc, rcvbuf (i))
324             continue
c
                i4 = rcvbuf (nrcv - 1) - 48
                if (i4 .gt. 9) i4 = i4 - 7
                lrc = lrc - i4
c
                i4 = rcvbuf (nrcv - 2) - 48
                if (i4 .gt. 9) i4 = i4 - 7
                lrc = lrc - (16 * i4)
c
                if (lrc .eq. 0) then
                    hh = 10 * rcvbuf  (4) + rcvbuf  (5) - 528
                    mm = 10 * rcvbuf  (6) + rcvbuf  (7) - 528
                    ss = 10 * rcvbuf  (8) + rcvbuf  (9) - 528
                    hs = 10 * rcvbuf (10) + rcvbuf (11) - 528
                    utset = (hh + (mm / 60.d0) + (ss / 3600.d0)
     :                    + (hs / 3600.d2)) / 24.d0
                    msg = '994; UT set by TCS to HH MM SS.FF'
                    msg (23:23) = char (rcvbuf  (4))
                    msg (24:24) = char (rcvbuf  (5))
                    msg (26:26) = char (rcvbuf  (6))
                    msg (27:27) = char (rcvbuf  (7))
                    msg (29:29) = char (rcvbuf  (8))
                    msg (30:30) = char (rcvbuf  (9))
                    msg (32:32) = char (rcvbuf (10))
                    msg (33:33) = char (rcvbuf (11))
                    call putmsg (msg)
                    clkfl = - 1
                   time8 = timer1
                else
                   ok = .false.
                   if (errct .lt. mxerr) then
                      msg = '041: TCS UT     com checksum error'
                      call putmsg (msg)
                   endif
                endif
c
             else
                if (errct .lt. mxerr) then
                   call putmsg ('043: TCS UT     command data error')
                endif
             endif
c
          else
             if (errct .lt. mxerr) then
                msg = '044: TCS UT     command com error X'
                msg (35:35) = char (errfl + 48)
                call putmsg (msg)
             endif
          endif
c
       endif
c
c
c         Keep track of the number of
c         communication error messages.
c         Don't display more than 3 in
c         a row.
c         -----------------------------
c
       if (ok) then
          if (errct .ge. mxerr) then
             call putmsg ('997; TCS error messages resumed')
          endif
          errct = 0
c
       else
          errct = min (errct + 1, mxerr+1)
          if (errct .eq. mxerr) then
             call putmsg ('030: TCS error messages suspended')
          endif
       endif
c
  990  continue
       return
       end
